using HarmonyLib;
using RimWorld;
using System.Collections.Generic;
using Verse;

namespace StorageTweaks
{
    //public override IEnumerable<InspectTabBase> Thing::GetInspectTabs()
    [HarmonyPatch(typeof(Thing))]
    [HarmonyPatch("GetInspectTabs")]
    public static class Building_Storage_GetInspectTabs_Patch
    {

        [HarmonyPostfix]
        public static void GetInspectTabs_Postfix(Thing __instance, ref IEnumerable<InspectTabBase> __result)
        {
            // Log.Message("HI2: " + __instance);
            if(__instance is Building_Storage)
            {
                __result = new List<InspectTabBase>(__result).AddItem(StorageTweaks.inspectorTab);
            }
        }

    }

    //public override void ExposeData()
    [HarmonyPatch(typeof(Building_Storage))]
    [HarmonyPatch("ExposeData")]
    public static class Building_Storage_ExposeData_Patch
    {

        [HarmonyPostfix]
        public static void ExposeData_Postfix(Building_Storage __instance)
        {
            //Log.Message("HI: " + __instance);
            StorageTweaksData data = StorageTweaks.registry.data(__instance);
            data.ExposeData();
        }

    }
}