using HarmonyLib;
using RimWorld;
using Verse;
using Verse.AI;

namespace StorageTweaks
{
    //public static Job HaulToCellStorageJob(Pawn p, Thing t, IntVec3 storeCell, bool fitInStoreCell)
    [HarmonyPatch(typeof(HaulAIUtility))]
    [HarmonyPatch("HaulToCellStorageJob")]
    public static class HaulAIUtility_HaulToCellStorageJob_Patch
    {

        [HarmonyPostfix]
        public static void HaulToCellStorageJob_Postfix(ref Job __result, Pawn p, Thing t, IntVec3 storeCell, bool fitInStoreCell)
        {
            if(fitInStoreCell == true)
            {
                return;
            }

            SlotGroup storage = p.Map.haulDestinationManager.SlotGroupAt(storeCell);
            if(storage == null)
            {
                return;
            }

            float storageLimit = StorageTweaks.registry.data(storage.parent as ISlotGroupParent).storageLimit;
            if(storageLimit != 1f)
            {
                int amountToAccept = StorageTweaksUtility.amountToAccept(t, storage, storageLimit);
                if(amountToAccept >= 0)
                {
                    // Log.Message("1");
                    __result.count = (amountToAccept > 0) ? amountToAccept : 1;
                }
            }
        }
    }
}