using HarmonyLib;
using RimWorld;

namespace StorageTweaks
{
    //public static void Copy(StorageSettings s)
    [HarmonyPatch(typeof(StorageSettingsClipboard))]
    [HarmonyPatch("Copy")]
    public static class SSC_Copy_Patch
    {
        private static StorageTweaksData storedSettings;

        [HarmonyPostfix]
        public static void Postfix(StorageSettings s)
        {
            if(s.owner is ISlotGroupParent)
            {
                storedSettings = Settings(s);
            }
        }

        public static StorageTweaksData StoredSettings(StorageSettings s)
        {
            if(storedSettings == null)
            {
                return Settings(s);
            }
            else
            {
                return storedSettings.Copy();
            }
        }

        private static StorageTweaksData Settings(StorageSettings s)
        {
            return StorageTweaks.registry.data(s.owner as ISlotGroupParent);
        }
    }

    //public static void PasteInto(StorageSettings s)
    [HarmonyPatch(typeof(StorageSettingsClipboard))]
    [HarmonyPatch("PasteInto")]
    public static class SSC_PasteInto_Patch
    {
        [HarmonyPostfix]
        public static void Postfix(StorageSettings s)
        {
            if(s.owner is ISlotGroupParent)
            {
                StorageTweaks.registry.replace(s.owner as ISlotGroupParent, SSC_Copy_Patch.StoredSettings(s));
            }
        }
    }
}