using Verse;

namespace StorageTweaks
{

    public class StorageTweaksData : IExposable
    {
        public float haulThreshold;
        public float storageLimit;
        public float localStorage;
        public int mergingDelay;
        public int lastStoredTick;
        public int lastMergingTick;

        public StorageTweaksData() : this(
            1f, // haulThreshold
            1f, // storageLimit
            0f, // localStorage
            0, // mergingDelay
            0, // lastStoredTick
            0  // lastMergingTick
        )
        { }

        public StorageTweaksData(
            float haulThreshold,
            float storageLimit,
            float localStorage,
            int mergingDelay,
            int lastStoredTick,
            int lastMergingTick
        )
        {
            this.haulThreshold = haulThreshold;
            this.storageLimit = storageLimit;
            this.localStorage = localStorage;
            this.mergingDelay = mergingDelay;
            this.lastStoredTick = lastStoredTick;
            this.lastMergingTick = lastMergingTick;
        }

        public void ExposeData()
        {
            Scribe_Values.Look<float>(ref haulThreshold, "ST_haulThreshold", 1f, false);
            Scribe_Values.Look<float>(ref storageLimit, "ST_storageLimit", 1f, false);
            Scribe_Values.Look<float>(ref localStorage, "ST_localStorage", 0f, false);
            Scribe_Values.Look<int>(ref mergingDelay, "ST_mergingDelay", 0, false);
            //Scribe_Values.Look<int>(ref lastStoredTick, "ST_lastStoredTick", 0, false);
        }

        public StorageTweaksData Copy()
        {
            return new StorageTweaksData(
                haulThreshold,
                storageLimit,
                localStorage,
                mergingDelay,
                lastStoredTick,
                lastMergingTick
            );
        }
    }

}