using RimWorld;
using System.Collections.Generic;

namespace StorageTweaks
{

    public class StorageTweaksRegistry
    {
        private Dictionary<ISlotGroupParent, StorageTweaksData> storageRegistry;

        public StorageTweaksRegistry()
        {
            storageRegistry = new Dictionary<ISlotGroupParent, StorageTweaksData>();
        }

        public StorageTweaksData data(ISlotGroupParent storage)
        {
            if(!storageRegistry.ContainsKey(storage))
            {
                storageRegistry.Add(storage, new StorageTweaksData());
            }

            return storageRegistry[storage];
        }

        public void replace(ISlotGroupParent storage, StorageTweaksData settings)
        {
            storageRegistry[storage] = settings;
        }

    }

}